diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java b/src/main/java/net/minecraft/client/render/block/model/PumpkinPieBlockModel.java
similarity index 89%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java
rename to src/main/java/net/minecraft/client/render/block/model/PumpkinPieBlockModel.java
index 75560dc50..82cef26e1 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PumpkinPieBlockModel.java
@@ -1,19 +1,18 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockCake;
-import net.minecraft.core.block.BlockEdible;
+import net.minecraft.core.block.EdibleBlock;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelPumpkinPie<T extends Block> extends BlockModelStandard<T>{
+public class PumpkinPieBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie_side");
     protected IconCoordinate insideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie_inside");
     protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie_top");
 
-    public BlockModelPumpkinPie(Block block) {
+    public PumpkinPieBlockModel(Block block) {
         super(block);
         float f = 0.0625F;
         float f1 = 0.375F;
@@ -48,7 +47,7 @@ public class BlockModelPumpkinPie<T extends Block> extends BlockModelStandard<T>
         boolean insideEast = sliceX == 0 ;
         boolean insideWest = sliceX == 1;
 
-        maxSlices = ((BlockEdible) block).maxBites;
+        maxSlices = ((EdibleBlock) block).maxBites;
         block.setBlockBounds(xMin + offsetXMin, 0.0F, zMin + offsetZMin, xMax - offsetXMax, 0.375F, zMax - offsetZMax);
         renderSide(tessellator, block, x, y, z, Side.TOP, 0);
         renderSide(tessellator, block, x, y, z, Side.BOTTOM, 0);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/src/main/java/net/minecraft/client/render/block/model/RailBlockModel.java
similarity index 90%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
rename to src/main/java/net/minecraft/client/render/block/model/RailBlockModel.java
index 865ee6499..a53bf2c8f 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RailBlockModel.java
@@ -1,21 +1,22 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRail;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.RailBlock;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
+public class RailBlockModel<T extends RailBlock> extends StandardBlockModel<T> {
     protected IconCoordinate railCurve = TextureRegistry.getTexture("minecraft:block/rail_turn");
     protected IconCoordinate powerActive = TextureRegistry.getTexture("minecraft:block/rail_powered_active");
     protected IconCoordinate powerActiveOverlay = TextureRegistry.getTexture("minecraft:block/rail_powered_overlay");
 
-    public BlockModelRail(Block block) {
+    public RailBlockModel(Block block) {
         super(block);
         this.hasOverbright = true;
     }
@@ -117,7 +118,7 @@ public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
     @Override
     public IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, int side)
     {
-        if (block.id != Block.railPowered.id || (blockAccess.getBlockMetadata(x, y, z) & 8) == 0) return null;
+        if (block.id != Blocks.RAIL_POWERED.id || (blockAccess.getBlockMetadata(x, y, z) & 8) == 0) return null;
 
         return powerActiveOverlay;
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/RedstonePumpkinBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/RedstonePumpkinBlockModel.java
new file mode 100644
index 000000000..4e0b56ceb
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/RedstonePumpkinBlockModel.java
@@ -0,0 +1,29 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.RedstonePumpkinBlock;
+import net.minecraft.core.util.helper.Side;
+
+public class RedstonePumpkinBlockModel extends HorizontalRotationBlockModel<RedstonePumpkinBlock> {
+    protected IconCoordinate overlay = TextureRegistry.getTexture("minecraft:block/pumpkin_redstone_overlay");
+    public RedstonePumpkinBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data)
+    {
+        if(side.getId() == data)
+        {
+            return overlay;
+        }
+        return null;
+    }
+
+    @Override
+    public boolean hasOverbright(){
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java b/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java
similarity index 92%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java
rename to src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java
index 8158b9bfb..e078b6683 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java
@@ -1,19 +1,19 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRedstoneWire;
+import net.minecraft.core.block.RedstoneWireBlock;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
 
-public class BlockModelRedstoneWire<T extends Block> extends BlockModelStandard<T>{
+public class RedstoneWireBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate wireStraight = TextureRegistry.getTexture("minecraft:block/wire_redstone_straight");
     protected IconCoordinate wireCross = TextureRegistry.getTexture("minecraft:block/wire_redstone_cross");
-    public BlockModelRedstoneWire(Block block) {
+    public RedstoneWireBlockModel(Block block) {
         super(block);
         withTextures("minecraft:block/wire_redstone_cross");
     }
@@ -49,32 +49,32 @@ public class BlockModelRedstoneWire<T extends Block> extends BlockModelStandard<
         float blue = color.getBlue() / 255.0f;
 
         tessellator.setColorOpaque_F(brightness * red, brightness * green, brightness * blue);
-        boolean west = BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x - 1, y, z, 1) || !renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x - 1, y - 1, z, -1);
-        boolean east = BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x + 1, y, z, 3) || !renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x + 1, y - 1, z, -1);
-        boolean north = BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x, y, z - 1, 2) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x, y - 1, z - 1, -1);
-        boolean south = BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x, y, z + 1, 0) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x, y - 1, z + 1, -1);
+        boolean west = RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x - 1, y, z, 1) || !renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x - 1, y - 1, z, -1);
+        boolean east = RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x + 1, y, z, 3) || !renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x + 1, y - 1, z, -1);
+        boolean north = RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y, z - 1, 2) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y - 1, z - 1, -1);
+        boolean south = RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y, z + 1, 0) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y - 1, z + 1, -1);
         boolean westUp = false;
         boolean eastUp = false;
         boolean northUp = false;
         boolean southUp = false;
         if(!renderBlocks.blockAccess.isBlockOpaqueCube(x, y + 1, z))
         {
-            if(renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x - 1, y + 1, z, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x - 1, y + 1, z, -1))
             {
                 west = true;
                 westUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x + 1, y + 1, z, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x + 1, y + 1, z, -1))
             {
                 east = true;
                 eastUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x, y + 1, z - 1, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y + 1, z - 1, -1))
             {
                 north = true;
                 northUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && BlockRedstoneWire.isPowerProviderOrWire(renderBlocks.blockAccess, x, y + 1, z + 1, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y + 1, z + 1, -1))
             {
                 south = true;
                 southUp = true;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java b/src/main/java/net/minecraft/client/render/block/model/RepeaterBlockModel.java
similarity index 76%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
rename to src/main/java/net/minecraft/client/render/block/model/RepeaterBlockModel.java
index 961c61704..827541ee0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RepeaterBlockModel.java
@@ -3,15 +3,16 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRedstoneRepeater;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.RepeaterBlock;
 import net.minecraft.core.world.WorldSource;
 
 @SuppressWarnings("unchecked")
-public class BlockModelRepeater extends BlockModelStandard<BlockRedstoneRepeater> {
-	private static final BlockModelTorch<Block> modelTorchActive = (BlockModelTorch<Block>) BlockModelDispatcher.getInstance().getDispatch(Block.torchRedstoneActive);
-    private static final BlockModelTorch<Block> modelTorchIdle = (BlockModelTorch<Block>) BlockModelDispatcher.getInstance().getDispatch(Block.torchRedstoneIdle);
+public class RepeaterBlockModel extends StandardBlockModel<RepeaterBlock> {
+	private static final TorchBlockModel<Block> modelTorchActive = (TorchBlockModel<Block>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_ACTIVE);
+    private static final TorchBlockModel<Block> modelTorchIdle = (TorchBlockModel<Block>) BlockModelDispatcher.getInstance().getDispatch(Blocks.TORCH_REDSTONE_IDLE);
 
-    public BlockModelRepeater(Block block) {
+    public RepeaterBlockModel(Block block) {
         super(block);
     }
 
@@ -65,25 +66,25 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRedstoneRepeater
         {
             case 0: // '\0'
                 d4 = -0.3125D;
-                d2 = BlockRedstoneRepeater.field_22024_a[j1];
+                d2 = RepeaterBlock.torchPosOffset[j1];
                 break;
 
             case 2: // '\002'
                 d4 = 0.3125D;
-                d2 = -BlockRedstoneRepeater.field_22024_a[j1];
+                d2 = -RepeaterBlock.torchPosOffset[j1];
                 break;
 
             case 3: // '\003'
                 d3 = -0.3125D;
-                d1 = BlockRedstoneRepeater.field_22024_a[j1];
+                d1 = RepeaterBlock.torchPosOffset[j1];
                 break;
 
             case 1: // '\001'
                 d3 = 0.3125D;
-                d1 = -BlockRedstoneRepeater.field_22024_a[j1];
+                d1 = -RepeaterBlock.torchPosOffset[j1];
                 break;
         }
-        BlockModelTorch<Block> modelTorch = block.isRepeaterPowered ? modelTorchActive : modelTorchIdle;
+        TorchBlockModel<Block> modelTorch = block.isRepeaterPowered ? modelTorchActive : modelTorchIdle;
         modelTorch.renderTorchAtAngle(tessellator, (double)x + d1, (double)y + d, (double)z + d2, 0.0D, 0.0D);
         modelTorch.renderTorchAtAngle(tessellator, (double)x + d3, (double)y + d, (double)z + d4, 0.0D, 0.0D);
         return true;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/src/main/java/net/minecraft/client/render/block/model/RopeBlockModel.java
similarity index 94%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
rename to src/main/java/net/minecraft/client/render/block/model/RopeBlockModel.java
index cd322e604..29d119625 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RopeBlockModel.java
@@ -2,15 +2,15 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLanternFirefly;
-import net.minecraft.core.block.BlockRope;
+import net.minecraft.core.block.FireflyLanternBlock;
+import net.minecraft.core.block.RopeBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelRope<T extends BlockRope>
-extends BlockModelStandard<T> {
-    public BlockModelRope(Block block) {
+public class RopeBlockModel<T extends RopeBlock>
+extends StandardBlockModel<T> {
+    public RopeBlockModel(Block block) {
         super(block);
     }
 
@@ -90,7 +90,7 @@ extends BlockModelStandard<T> {
         int blockZ = z + side.getOffsetZ();
         Block _block = worldSource.getBlock(blockX, blockY, blockZ);
         if (side == Side.BOTTOM){
-            if (_block instanceof BlockLanternFirefly && (worldSource.getBlockMetadata(blockX, blockY, blockZ) & 0b1) != 0){
+            if (_block instanceof FireflyLanternBlock && (worldSource.getBlockMetadata(blockX, blockY, blockZ) & 0b1) != 0){
                 return true;
             }
         } else if (side == Side.TOP) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java b/src/main/java/net/minecraft/client/render/block/model/RotatableBlockModel.java
similarity index 68%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
rename to src/main/java/net/minecraft/client/render/block/model/RotatableBlockModel.java
index cabe6281d..ea5bb32c7 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRotatable.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RotatableBlockModel.java
@@ -1,12 +1,12 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 
-public class BlockModelRotatable<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelRotatable(Block block) {
+public class RotatableBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public RotatableBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java b/src/main/java/net/minecraft/client/render/block/model/SeatBlockModel.java
similarity index 90%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
rename to src/main/java/net/minecraft/client/render/block/model/SeatBlockModel.java
index cee6a8afd..dc8996313 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
+++ b/src/main/java/net/minecraft/client/render/block/model/SeatBlockModel.java
@@ -4,8 +4,8 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelSeat<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelSeat(Block block) {
+public class SeatBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public SeatBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java b/src/main/java/net/minecraft/client/render/block/model/SlabBlockModel.java
similarity index 74%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
rename to src/main/java/net/minecraft/client/render/block/model/SlabBlockModel.java
index d17f3ffdb..9612a2eff 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
+++ b/src/main/java/net/minecraft/client/render/block/model/SlabBlockModel.java
@@ -1,15 +1,15 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSlab;
+import net.minecraft.core.block.SlabBlock;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelSlab<T extends BlockSlab> extends BlockModelStandard<T> {
-    public BlockModelSlab(Block block){
+public class SlabBlockModel<T extends SlabBlock> extends StandardBlockModel<T> {
+    public SlabBlockModel(Block block){
         super(block);
-        this.atlasIndices = ((BlockModelStandard<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.modelBlock)).atlasIndices;
+        this.atlasIndices = ((StandardBlockModel<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.modelBlock)).atlasIndices;
         withCustomItemBounds(0, 0, 0, 1, 0.5d, 1);
     }
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java b/src/main/java/net/minecraft/client/render/block/model/SlabMarbleBlockModel.java
similarity index 72%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
rename to src/main/java/net/minecraft/client/render/block/model/SlabMarbleBlockModel.java
index 36f7f7a13..492fb67a1 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabMarble.java
+++ b/src/main/java/net/minecraft/client/render/block/model/SlabMarbleBlockModel.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSlab;
+import net.minecraft.core.block.SlabBlock;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelSlabMarble<T extends BlockSlab> extends BlockModelSlab<T> {
+public class SlabMarbleBlockModel<T extends SlabBlock> extends SlabBlockModel<T> {
     protected IconCoordinate slabSide = TextureRegistry.getTexture("minecraft:block/carved_marble");
-    public BlockModelSlabMarble(Block block) {
+    public SlabMarbleBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java b/src/main/java/net/minecraft/client/render/block/model/SlabPaintedBlockModel.java
similarity index 64%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
rename to src/main/java/net/minecraft/client/render/block/model/SlabPaintedBlockModel.java
index cdf25252c..20d885587 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSlabPainted.java
+++ b/src/main/java/net/minecraft/client/render/block/model/SlabPaintedBlockModel.java
@@ -1,20 +1,20 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSlab;
+import net.minecraft.core.block.SlabBlock;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelSlabPainted<T extends BlockSlab> extends BlockModelSlab<T> {
-    public BlockModelSlabPainted(Block block) {
+public class SlabPaintedBlockModel<T extends SlabBlock> extends SlabBlockModel<T> {
+    public SlabPaintedBlockModel(Block block) {
         super(block);
     }
 
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
         meta = meta >> 4;
-        return BlockModelPlanksPainted.texCoords[meta & 0x0F];
+        return PlanksPaintedBlockModel.texCoords[meta & 0x0F];
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java b/src/main/java/net/minecraft/client/render/block/model/SpikesBlockModel.java
similarity index 95%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
rename to src/main/java/net/minecraft/client/render/block/model/SpikesBlockModel.java
index 83e37bfae..5b8134fd0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
+++ b/src/main/java/net/minecraft/client/render/block/model/SpikesBlockModel.java
@@ -1,14 +1,14 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSpikes;
+import net.minecraft.core.block.SpikesBlock;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelSpikes<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelSpikes(Block block) {
+public class SpikesBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public SpikesBlockModel(Block block) {
         super(block);
     }
 
@@ -25,7 +25,7 @@ public class BlockModelSpikes<T extends Block> extends BlockModelStandard<T> {
         block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F);
         renderStandardBlock(tessellator, block, x, y, z);
 
-        if(BlockSpikes.isSpikesUp(metaData)) {
+        if(SpikesBlock.isSpikesUp(metaData)) {
             float brightness = 1.0f;
             if(LightmapHelper.isLightmapEnabled()) {
             	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/src/main/java/net/minecraft/client/render/block/model/StairsBlockModel.java
similarity index 94%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
rename to src/main/java/net/minecraft/client/render/block/model/StairsBlockModel.java
index ad79f2713..d920e4fc4 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/src/main/java/net/minecraft/client/render/block/model/StairsBlockModel.java
@@ -1,19 +1,19 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockStairs;
+import net.minecraft.core.block.StairsBlock;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelStairs<T extends BlockStairs> extends BlockModelStandard<T> {
-    public BlockModelStairs(Block block) {
+public class StairsBlockModel<T extends StairsBlock> extends StandardBlockModel<T> {
+    public StairsBlockModel(Block block) {
         super(block);
-        this.atlasIndices = ((BlockModelStandard<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.modelBlock)).atlasIndices;
+        this.atlasIndices = ((StandardBlockModel<?>)BlockModelDispatcher.getInstance().getDispatch(this.block.modelBlock)).atlasIndices;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java b/src/main/java/net/minecraft/client/render/block/model/StairsPaintedBlockModel.java
similarity index 64%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
rename to src/main/java/net/minecraft/client/render/block/model/StairsPaintedBlockModel.java
index c9be4dca7..257979d71 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairsPainted.java
+++ b/src/main/java/net/minecraft/client/render/block/model/StairsPaintedBlockModel.java
@@ -1,20 +1,20 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockStairs;
+import net.minecraft.core.block.StairsBlock;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelStairsPainted<T extends BlockStairs> extends BlockModelStairs<T> {
-    public BlockModelStairsPainted(Block block) {
+public class StairsPaintedBlockModel<T extends StairsBlock> extends StairsBlockModel<T> {
+    public StairsPaintedBlockModel(Block block) {
         super(block);
     }
 
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
         meta = meta >> 4;
-        return BlockModelPlanksPainted.texCoords[meta & 0x0F];
+        return PlanksPaintedBlockModel.texCoords[meta & 0x0F];
     }
 
     @Override
